'Public System Call/Declarations
Imports System
Imports System.Collections
Imports System.IO
Imports Microsoft.VisualBasic

Module mdlMain

    'Generic Public Vairbales
    Public intLoop As Integer 'Integer for use with loop counting
    Public intLoop2 As Integer 'Integer for use with loop counting
    Public strAppName As String = System.Environment.GetCommandLineArgs()(0) 'A string variable to store the program name which is always the first argument on a CLI application
    Public rflAssembly As Reflection.Assembly = System.Reflection.Assembly.GetExecutingAssembly() 'This is an Assembly reference to the Reflection assemby (which holds information about the running program)
    Public strAppPath As String = rflAssembly.Location.Substring(0, InStrRev(rflAssembly.Location, "\")) 'A string variable to store the application path which is extracted from my reference to the Reflection Assembly
    Public strDebug As String = vbNewLine 'A string variable to store debug information for printing to the user. Start it off with vbNewLine for padding
    Public bolVVVerbose As Boolean 'A boolean variable to store weather we are displaying verbose debuging info
    Public strLogFile As String 'A string variable to store the full path to the log file
    Public strLogName As String = Left(strAppName, Len(strAppName) - 4) & "_" & Replace(Date.Today, "/", "-") & "_" & Replace(TimeOfDay, ":", "-") & ".log" 'A string variable to store the file name of the log file
    Public bolLogging As Boolean 'A boolean variable to state weather we are saving an output log

    'Program Public Variables
    Public strRunMode As String 'A string variable to store the run mode of the program
    Public strWorkDir As String 'A string variable to store the working directory to scan
    Public strDestDir As String 'A string variable to store the destination directory to move/copy files to
    Public dtSupplied As Date 'A date variable to store the date given by the user for use date access/modified/creation filters
    Public bolAccessed As Boolean 'A boolean variable to state weather date last accessed is used
    Public bolModified As Boolean 'A boolean variable to state weather date last modified is used
    Public bolCreated As Boolean 'A boolean variable to state weather the date created is used
    Public objFileExt() As String 'An array of strings to store the list of passed file extentions

    'Public File Details Variables
    Public lstFiles As New ArrayList 'An array list to store the list of files to be actioned
    Public lstSizes As New ArrayList 'An array list to store the list of file sizes for the files to be actioned
    Public intTotalSize As Long 'An integer variable to store the total size of all the files to be actions
    Public intTotalFiles As Integer 'An integer variable to store the total number of files to be actioned
    Public intTotalScandFiles As Integer 'An integer variable to store the total number of files scanned (to be actioned or not)
    Public intTotalScandSize As Long 'An integer variable to store the total size of files scanned (to be actioned or not)
    Public intTotalFolders As Long 'An integer variable to store the number of folders scanned

    'Public Command Options Help Text Variables
    Public strHelpRunMode As String = "Use: " & strAppName & " -d/m/c/o" & vbNewLine & vbNewLine & "-d   Dry Run: Run through a proposed actions and log the action that would take place" & vbNewLine & vbNewLine & "-m   Move: Move files from the working directory to the target directory that match the search criteria" & vbNewLine & vbNewLine & "-c   Copy: Copy files from the working directory to the target directory that match the search criteria (Useful incase a file was processed incorrectly)" & vbNewLine & vbNewLine & "-o   Delete: THIS WILL DELETE FILES THAT MATCH THE SEARCH CRITERIA AND SHOULD BE USED WITH EXTREME CAUTION" 'A string variable to store the full help text for the different run modes
    Public strHelpWorkDir As String = "Use: " & strAppName & " -w C:\MyFolder\Archived" & vbNewLine & "**You must have Read and Write permissions in the working directory**" 'A string variable to store the full help text for the working directory option
    Public strHelpDestDir As String = "Use: " & strAppName & " -n E:\MyFolder\LongTermStore" & vbNewLine & "**You must have Read and Write permissions in the destination directory**" 'A string variable to store the full help text for the destination directory option
    Public strHelpFileExt As String = "Any file extention can be given or '.*' which is used for all file extentions" & vbNewLine & "For multiple values seperate them with a comma     `" & vbNewLine & vbNewLine & "Use: " & strAppName & " -x .txt,.mp3,.avi" & vbNewLine & "Or Use: " & strAppName & " -x .*" 'A string variable to store the full help text for the file extention options
    Public strHelpDateAoM As String = "Use: " & strAppName & " -a/e/g 21/06/1973" & vbNewLine & "-a   Date Last Accessed: Files which have not been ACCESSED since the date given will be actioned" & vbNewLine & "-e   Date Last Modified: Files which have not been MODIFIED since the date given will be actioned" & vbNewLine & "-e   Date Created: Files which have been CREATED before this date will be actioned" 'A string variable to store the full help text for the last date accessed/modified methods
    Public strHelpVerbose As String = "The verbose option simple enables a greater more verbose level of debug logging for when errors occued and the debug log is dumped to the screen" & vbNewLine & "Use: " & strAppName & " -v" 'A string variable to store the full help text for the verbose option
    Public strHelpLogging As String = "This option enables the creation of an output log which will store debugging info of the program. You use the logging switch '-l' and specifiy a full path to store the log in a custom directory or if no path is given the program execution directorty is used" & vbNewLine & "Use :" & strAppName & " -l C:\Folder1\Folder2\Logs" & vbNewLine & "Or use: " & strAppName & " -l    Which will use:" & vbNewLine & strAppPath & "\" & strAppName & "-" & Date.Today & "-" & TimeOfDay & ".log" 'A string variable to store the full help test about the logging option

    'Public Information Variables
    Public strProgDesc As String = strAppName & " - A program for copying or moving files from one directory to another based on either their:" & vbNewLine & vbNewLine & "Date Last Accessed - The date the file was last opened or viewed" & vbNewLine & vbNewLine & "Date Last Modified - The last time the file was editied or modified" & vbNewLine & vbNewLine & "This process can be further filtered with file extention filtering" 'A string variable to store the program description
    Public strProgUsage As String = "Program use is [executable name].exe [run mode -d/m/c/o]" & vbNewLine & "[working directory -w C:\MyFolder]" & vbNewLine & "[target directory -n E:\MyFolder]" & vbNewLine & "[file extension -x .txt,.mp3,.avi]" & vbNewLine & "[date last accessed/modified/created -a/e/g 25/12/1234]" & vbNewLine & "[be verbose -v]" & vbNewLine & "[enable output logging -l C:\Folder1\Folder2\Logs]" & vbNewLine & "[display credits -z]" 'A string variable to store the program usage commands
    Public strProgCredits As String = "" 'Program Credits

    Sub Main(ByVal args() As String) 'Main Sub-Routine, take the value of passes text and splts them into strings in the array "args()"

        On Error GoTo ErrorLabel 'If anything bad happens, go to ErrorLabel and tell the user all about it over a cup of tea

        If args.Length = 0 Then 'Check we actually have some arugments?
            Console.WriteLine("You have specified an insufficient number of arguments;") 'If not, tell the user
            Console.WriteLine(strProgUsage)
            Console.WriteLine("Or use: " & strAppName & " --help " & vbTab & " for more information")
            End 'End the program
        End If 'End our IF statemet

        For intLoop = 0 To args.Length - 1 'Loop through each command line argument
            Select Case args(intLoop) 'Select each argument and see what it is...
                Case "-d" 'Dry run
                    strRunMode = "dry" 'Set the run mode to dry run
                    DebugInfo("Run Mode:  Dry", False)  'Update the debug information
                Case "-m" 'Move files
                    strRunMode = "move" 'Set the run mode to move
                    DebugInfo("Run Mode:  Move", False) 'Update the debug information
                Case "-c" 'Copy files
                    strRunMode = "copy" 'Set the run mode to copy
                    DebugInfo("Run Mode:  Copy", False) 'Update the debug information
                Case "-o" 'Delete files
                    strRunMode = "delete" 'Set the run mode to delete
                    DebugInfo("Run Mode:  Delete", False) 'Update the debug information
                Case "-w" 'Working directory start point
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the working directory
                        Console.WriteLine("Please specify a directory to work from") 'If not tell the user they need to supply a valid entry
                        Console.WriteLine(strHelpWorkDir) 'Give the full help text
                        End 'End the program
                    Else 'Else if there is another command ling argument available, grab it!
                        strWorkDir = args(intLoop + 1) 'Select the next command line argument as it will be the working diretory
                        DebugInfo("Working Directory:   " & args(intLoop + 1), False) 'Update the debug information
                        intLoop += 1 'increment the intLoop integer to make sure we don't try to use the working directory as a command line arugment
                    End If 'End the additional command line argument IF
                Case "-n" 'Destination directory to copy/move files to
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the target directory
                        Console.WriteLine("Please specify a target directory to copy/move files to") 'If not tell the user they need to supply a valid entry
                        Console.WriteLine(strHelpDestDir) 'Give the full help text
                        End 'End the program
                    Else 'Else if there is another command ling argument available, grab it!
                        strDestDir = args(intLoop + 1) 'Select the next command line argument as it will be the target diretory
                        DebugInfo("Target Directory:   " & args(intLoop + 1), False) 'Update the debug information
                        intLoop += 1 'Increment the intLoop integer to make sure we don't try to use the target directory as a command line arugment
                    End If 'End the additional command line argument IF
                Case "-x" 'File extentions to look for
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the file extentions
                        Console.WriteLine("Please specify at least one valid file extenion") 'If not tell the user they need to supply a valid entry
                        Console.WriteLine(strHelpFileExt) 'Give the full help text
                        End 'End the program
                    Else 'Else if there is another command ling argument available, grab it!
                        'strTemp = args(intLoop + 1)
                        objFileExt = Split(args(intLoop + 1), ",") 'Select the next command line argument as it will be the target diretory
                        DebugInfo("File Extentions:   ", False) 'Update the debug information
                        For intLoop2 = 0 To (UBound(objFileExt) - LBound(objFileExt)) 'Loop round each file extention put into objFileExt by the Split() function
                            DebugInfo(objFileExt.GetValue(intLoop2), False) 'Update the debug information
                        Next 'Go to the next file extention
                        intLoop += 1 'Increment the intLoop integer to make sure we don't try to use the target directory as a command line arugment
                    End If 'End the additional command line argument IF
                Case "-a" 'Date last accessed
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the last date accessed
                        Console.WriteLine("Please specify the minimum date the file was last accessed ") 'If not tell the user they need to supply a valid entry
                        Console.WriteLine(strHelpDateAoM) 'Give the full help text
                        End 'End the program
                    Else 'Else if there is another command ling argument available, grab it!
                        dtSupplied = args(intLoop + 1) 'Select the next command line argument as it will be the last date access
                        bolAccessed = True 'Set the 'date last accessed' boolean to true
                        DebugInfo("Date Last Accessed:   " & args(intLoop + 1), False) 'Update the debug information
                        intLoop += 1 'Increment the intLoop integer to make sure we don't try to use the last date access as a command line arugment
                    End If 'End the additional command line argument IF
                Case "-e" 'Date last modified
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the last date modified
                        Console.WriteLine("Please specify the minimum date the file was last modified") 'If not tell the user they need to supply a valid entry
                        Console.WriteLine(strHelpDateAoM) 'Give the full help text
                        End 'End the program
                    Else 'Else if there is another command ling argument available, grab it!
                        dtSupplied = args(intLoop + 1) 'Select the next command line argument as it will be the last date modified
                        bolModified = True 'Set the 'date last modified' boolean to true
                        DebugInfo("Date Last Modified:   " & args(intLoop + 1), False) 'Update the debug information
                        intLoop += 1 'Increment the intLoop integer to make sure we don't try to use the date last modified as a command line arugment
                    End If 'End the additional command line argument IF
                Case "-g" 'Date created
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the date created
                        Console.WriteLine("Please specify the minimum date the file was created") 'If not tell the user they need to supply a valid entry
                        Console.WriteLine(strHelpDateAoM) 'Give the full help text
                        End 'End the program
                    Else 'Else if there is another command ling argument available, grab it!
                        dtSupplied = args(intLoop + 1) 'Select the next command line argument as it will be the last date modified
                        bolCreated = True 'Set the 'date last modified' boolean to true
                        DebugInfo("Date Last Modified:   " & args(intLoop + 1), False) 'Update the debug information
                        intLoop += 1 'Increment the intLoop integer to make sure we don't try to use the date created as a command line arugment
                    End If 'End the additional command line argument IF
                Case "-v" 'Display verbose info
                    bolVVVerbose = True 'Enable verbose info disclosure
                Case "--help" 'A request for help has been given
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be a request for the full help text about a command...
                        Console.WriteLine(strProgDesc) 'Display the program description text
                        Console.WriteLine(strProgUsage) 'Display the program usage text
                        Console.WriteLine(vbNewLine & "For full details of a command line option use: " & strAppName & " --help [OPTION]" & vbNewLine & "Example: " & strAppName & " --help -d" & vbNewLine & "This will display the full help text about the dry run option")
                        End 'End the program
                    Else 'Another command line argument is available
                        Select Case args(intLoop + 1) 'Select the next command line argument to see if it has help text available
                            Case "-d" 'They have requested help for the 'dry' run mode
                                Console.WriteLine(strHelpRunMode)
                                End 'End the program
                            Case "-m" 'They have requested help for the 'move' run mode
                                Console.WriteLine(strHelpRunMode)
                                End 'End the program
                            Case "-c" 'They have requested help for the 'copy' run mode
                                Console.WriteLine(strHelpRunMode)
                                End 'End the program
                            Case "-o" 'They have requested help for the 'delete' run mode
                                Console.WriteLine(strHelpRunMode)
                                End 'End the program
                            Case "-w" 'They have requested help for the working directory option
                                Console.WriteLine(strHelpWorkDir)
                                End 'End the program
                            Case "-n" 'They have requested help for the target directory option
                                Console.WriteLine(strHelpDestDir)
                                End 'End the program
                            Case "-x" 'They have requested help for the file extention options
                                Console.WriteLine(strHelpFileExt)
                                End 'End the program
                            Case "-a" 'They have requested help for the 'date last accessed' filter method
                                Console.WriteLine(strHelpDateAoM)
                                End 'End the program
                            Case "-e" 'They have requested help for the 'date last modified' filter method
                                Console.WriteLine(strHelpDateAoM)
                                End 'End the program
                            Case "-g" 'They have requested help for the 'date created' filter method
                                Console.WriteLine(strHelpDateAoM)
                                End 'End the program
                            Case "-v" 'They have requested help for the verbose option
                                Console.WriteLine(strHelpVerbose)
                                End 'End the program
                            Case "-l" 'They have requested help for the logging option
                                Console.WriteLine(strHelpLogging)
                                End 'End the program
                            Case Else 'If the user has anything else that isn't recognised
                                Console.WriteLine("You have specified an incorrect option for requestion full help text") 'Tell the user they have specified an invalid argument
                                Console.WriteLine(strProgUsage) 'Display the program usage text
                                End 'End the program
                        End Select 'End the aditional command line select statement
                        End 'End the Program
                    End If 'End the additional command line argument IF
                Case "-l" 'The user has asked for a written text log
                    bolLogging = True 'Turn on the process of saving the output log (debugging info) to a text file
                    If intLoop + 1 > args.Length - 1 Then 'See if there is another command line argument which could possibly be the log location to save it
                        strLogFile = strAppPath & strLogName 'No extra details where provided so use the program directory is used with the log file name string
                    Else 'Else if there is another command ling argument available, use that as the log file directory
                        strLogFile = args(intLoop + 1) & strLogName 'Set the log file output full path and name to the user specified directory and the log file name string
                        intLoop += 1 'Increment the loop counter to skip the next check the next argument  as it was the log path
                    End If 'End the additional command line argument IF
                Case "-z" 'The user has asked for the credits
                    Credits() 'Call the credits function to display the credits
                    End 'End the program
            End Select 'End the select statement

        Next 'Loop to the next command line argument


        'After we have taken in all the user arguments lets see if we have enough input to do something;
        If strRunMode = "" Then 'The user hasn't specified a run mode
            Console.WriteLine(vbNewLine & "Please specify a run mode to either do a dry run, copy files or move files") 'Tell the user they haven't specified a run mode
            Console.WriteLine(strHelpRunMode) 'Display the run modes help text
            End 'End the program
        End If 'End the run mode IF
        If strWorkDir = "" Then 'The user hasn't specified a working directory to scan
            Console.WriteLine(vbNewLine & "Please specify a working directory to scan for file access/modification matching") 'Tell the user they haven't specified a working directory to scan
            Console.WriteLine(strHelpWorkDir) 'Display the working directory help text
            End 'End the program
        End If 'End the working directory IF
        If bolAccessed = False Then 'The user hasn't specified a last date accessed
            If bolModified = False Then 'The user hasn't specified a last date modified either,
                If bolCreated = False Then 'The user hasn't specified a date created either so we have nothing to work with
                    Console.WriteLine(vbNewLine & "Please specify either a date the file was last access, modified or created") 'Tell the user they haven't specified either the date last accessed or modified
                    Console.WriteLine(strHelpDateAoM) 'Display the date last access/modified help text
                    End 'End the program
                End If 'End the created IF
            End If 'End the modified IF
        End If 'End the accessed IF
        If bolAccessed = True Then 'The user has specified a 'date last accessed'
            If bolModified = True Then 'The user has also specified a 'date last modified'
                If bolCreated = True Then 'The user has also specified a 'date created'
                    Console.WriteLine(vbNewLine & "You can not specify a more than one: " & vbNewLine & "Date Last Accessed, Date Last Modified or Date Created when search for files. Please specify only one.") 'Tell the user they have specified both date methods
                    Console.WriteLine(strHelpDateAoM) 'Display the date last access/modified help text
                    End 'End the program
                End If 'End the date created IF
            End If 'End the modified IF
        End If 'End end Accessed IF
        If strRunMode <> "dry" Then 'If we doing either a copy or move operation then a destination directory is required
            If strDestDir = "" Then 'But the user hasn't given us one! Idiots!
                Console.WriteLine(vbNewLine & "Please specify a destination directory to where files shall either be copied or moved") 'Tell the user they haven't specified a Destination directory
                Console.WriteLine(strHelpDestDir) 'Display the destination directory help text
                Console.WriteLine(strHelpRunMode) 'Display the run modes help text
                End 'End the program
            End If 'End the destination directory IF
        End If 'End the run mode IF
        If objFileExt.Length = 0 Then 'The user hasn't specified any file extentions
            Console.WriteLine("Please specify at least one valid file extenion to look for, use '.*' for anything. For multiple values seperate them with a comma ','") 'Tell the user they need to specify a valid file extention option
            Console.WriteLine(strHelpFileExt) 'Display the file extention help text
            End 'End the program
        End If 'End the File Extention IF

        Select Case strRunMode 'See what run mode we have
            Case "dry" 'Just do a dry run that tells the user what would happen if they were to do a move or copy
                DryRun() 'Call the dry run function
                For intLoop = 0 To lstFiles.Count - 1 'Loop through the number of files flagged for action
                    Console.WriteLine(lstFiles(intLoop)) 'Write out each full path and name to the screen
                Next 'Loop to the next file that has been flagged
            Case "move" 'The user wishes to move files
                DryRun() 'Start by calling the dry run function
                Action() 'Then call the action function to move the files
            Case "copy" 'The user wishes to copy the files
                DryRun() 'Start by calling the dry run function
                Action() 'Then call the action function to move the files
        End Select 'End the Run Mode select statement

        Console.WriteLine(strDebug) 'Write out the debug info

        'Before we end the program we must see if the user has output logging enabled,
        If bolLogging = True Then 'If we do, write out the debugging log...
            Dim stmWriter As New StreamWriter(strLogFile, False) 'Declare a StreamWriter reference for use with saving the output log
            For intLoop = 0 To lstFiles.Count - 1
                stmWriter.WriteLine(lstSizes(intLoop) & " " & vbTab & vbTab & lstFiles(intLoop)) 'Write our the file size and full path to the log
            Next
            stmWriter.WriteLine(strDebug) 'Write the debug string to the debug log
            stmWriter.Close() 'Close the StreamWriter
        End If 'End the Logging IF

        End 'End the program


ErrorLabel:  'The code drops here is there is an error

        Console.WriteLine(vbNewLine & vbNewLine & "An error has occured during the operation. Please read below for further debugging information.") 'Tell the user an error has occured
        Console.WriteLine("Error Description:    " & Err.Description) 'Print the error description
        Console.WriteLine("Error Source:    " & Err.Source) 'Print the error source
        Console.WriteLine("Error Line:  " & Err.Erl()) 'Print the error line
        Console.WriteLine("Application Details " & vbNewLine & strDebug)  'Print our debug string
        End 'End the program

    End Sub 'End the Main() sub
   
    Public Sub DryRun() 'This sub routine runs through our specified sub directory gathering a list of actions to be performed

        Dim dirInfo As DirectoryInfo = New DirectoryInfo(strWorkDir) 'Set a reference point to the DirectoryInfo class at our user specified working directory
        RecurseFolders(dirInfo) 'Parse this to the recurse folders function to check for sub directories

        DebugInfo("Total number of files to be actioned:   " & intTotalFiles, False) 'Update the debug information
        DebugInfo("Total size of all files to be actioned:   " & SizeUnits(intTotalSize), False) 'Update the debug information
        DebugInfo("Total number of all files scanned:   " & intTotalScandFiles, True) 'Update the debug information
        DebugInfo("Total size of all files scanned:   " & SizeUnits(intTotalScandSize), True) 'Update the debug information
        DebugInfo("Total number of all folders scanned:   " & intTotalFolders, True) 'Update the debug information

    End Sub 'End the DryRun() sub

    Public Sub RecurseFolders(ByVal dirInfo As DirectoryInfo) 'This sub recurses the folders of the given working directory

        RecurseFiles(dirInfo) 'Check the files in this particular sub directory
        intTotalFolders += 1 'Increment the nubmer of folders scanned
        Dim dirNext As DirectoryInfo 'Create a DirectoryInfo class reference to view subdirectories of the passed directory to this 
        For Each dirNext In dirInfo.GetDirectories() 'Check this sub directory for further sub directories
            RecurseFolders(dirNext) 'Parse each directory we find to this sub for further checking
        Next 'Go to the next found sub directory

    End Sub 'End the RecurseFolders() Sub

    Public Sub RecurseFiles(ByVal dirInfo As DirectoryInfo) 'This sub recurses a folder looking at all files to see if we have any matching file extentions

        Dim aFile As FileInfo 'Create a FileInfo reference for check the properties of files
        For Each aFile In dirInfo.GetFiles() 'Loop through each file in the parsed sub directory
            intTotalScandFiles += 1 'Increment the total number of files scanned
            intTotalScandSize += aFile.Length 'Increment the total size of all files scanned
            For intLoop = 0 To (UBound(objFileExt) - LBound(objFileExt)) 'Then loop round each file extension we are searching for
                If aFile.Extension = objFileExt.GetValue(intLoop) Then 'And see if the current file has a matching extension
                    CheckFile(aFile.FullName)
                End If 'End the File Extention IF
            Next 'Loop to the next file extention
        Next 'Loop to the next file

    End Sub 'End the RecurseFiles() Sub

    Public Sub CheckFile(ByVal strFullName As String) 'This sub is called to check a file with a matching file extention for our dat method
        If bolAccessed = True Then 'See if we are using the 'date last accessed' method
            If File.GetLastAccessTime(strFullName) < dtSupplied Then 'We are, if the file last accessed property is older than that specified...
                AddFile(strFullName) 'Parse the file name to the AddFiles() sub to flag this file for action
            End If 'End the date comparison IF
        End If 'End the date accessed IF
        If bolModified = True Then 'See if we are using the 'date last modified' method
            If File.GetLastWriteTime(strFullName) < dtSupplied Then 'We are, if the file last modified property is older than that specified...
                AddFile(strFullName) 'Parse the file name to the AddFiles() sub to flag this file for action
            End If 'End the date comparison IF
        End If 'End the date modified IF
        If bolCreated = True Then 'See if we are using the 'date created' method
            If File.GetCreationTime(strFullName) < dtSupplied Then 'We are, if the file last modified property is older than that specified...
                AddFile(strFullName) 'Parse the file name to the AddFiles() sub to flag this file for action
            End If 'End the date comparison IF
        End If 'End the date created IF
    End Sub 'End the CheckFile() Sub

    Public Sub AddFile(ByVal strFullName As String) 'This sub adds the passed file name to the list of files to be actioned
        intTotalFiles += 1 'Increment the number of files that are being actioned
        intTotalSize += FileLen(strFullName) 'Add the length of this file to be total size of all files being actioned
        lstFiles.Add(strFullName) 'Add the file name to the list of files to be actioned
        lstSizes.Add(SizeUnits(FileLen(strFullName))) 'Add the file size to the list of file sizes for files to be actioned
    End Sub 'End the AddFile() sub

    Public Sub Action() 'This sub takes the compiled list of files to action and moves/copes the files to the target directory specified based on the run mode specified

        Dim strSplit() As String 'String to store the splits of the file name
        Dim strFileName As String 'String variable to store the file name of the file to be actioned

        For intLoop = 0 To lstFiles.Count - 1 'Loop through each file in the compiled file list
            strSplit = Split(lstFiles.Item(intLoop), "\") 'Split the full file name and path with the "\" backslash symbol
            strFileName = strSplit.GetValue(strSplit.GetUpperBound(0)) 'Get zthe final split as that will be the file name
            If strRunMode = "move" Then 'If the run mode is move...
                Console.WriteLine("Moving " & strFileName) 'Tell the user about the move
                File.Move(lstFiles.Item(intLoop), strDestDir & "\" & strFileName) 'Copy the current file to the target directory
            End If 'End the move IF
            If strRunMode = "copy" Then 'Is the current run mode copy?
                Console.WriteLine("Copying " & strFileName) 'Tell the user about the copy
                File.Copy(lstFiles.Item(intLoop), strDestDir & "\" & strFileName) 'Copy the current file to the target directory
            End If 'End the copy IF
            If strRunMode = "delete" Then 'Is the current run mode delete?
                Console.WriteLine("Deleting " & strFileName) 'Tell the user about the delete
                File.Delete(lstFiles.Item(intLoop)) 'Delete the current
            End If 'End the delete IF
        Next 'Loop to the next file

    End Sub 'End the Move() sub

    Public Function SizeUnits(ByVal intBytes As Long) As String 'This sub takes the parsed value and converts in into the text string size value of the nearest unit of measurement

        Select Case intBytes
            Case Is < 10 'Append a zero before the byte value if its less than 10
                Return ("0" & intBytes & " Bytes")
            Case Is < 1024 'Nearest unit of measurement is in bytes
                Return (intBytes & " Bytes")
            Case Is < 1048576 'Nearest unit of measurement is in kilo-bytes
                Return (Left(intBytes / 1000, Len(intBytes / 1000) - 2) & " KB")
            Case Is < 1073741824 'Nearest unit of measurement is in mega-bytes
                Return (Left(intBytes / 1000000, Len(intBytes / 1000000) - 4) & " MB")
            Case Is < 1099511627776 'Nearest unit of measurement is in giga-bytes
                Return (Left(intBytes / 1000000000, Len(intBytes / 1000000000) - 4) & " GB")
            Case Is < 1125899906842624 'nearest unit of measurement is in tera-bytes
                Return (Left(intBytes / 1000000000000, Len(intBytes / 1000000000000) - 4) & " TB")
            Case Else 'For anything bigger
                Return (intBytes & " Bytes (PB?)")
        End Select

    End Function 'End the SizeUnits() Sub

    Public Sub DebugInfo(ByVal strDebugInfo As String, ByVal bolVerbos As Boolean) 'This sub add a parsed string to the debug string to printing to the user

        If bolVerbos = True Then 'Are we adding something that is only for verbose debugging
            If bolVVVerbose = True Then 'Is verbose logging enabled?
                strDebug &= vbNewLine & strDebugInfo 'It is so add the parsed information to the debugging string
            End If 'It's not so don't add it to the debugging info
        Else 'This isn't for verbose logging so it just gets added what ever the weather
            strDebug &= vbNewLine & strDebugInfo 'Add it in
        End If 'End the IF statement

    End Sub 'End the DebugInfo() sub

    Public Sub Credits() 'This sub displays the program credits 

        'The normal command window height is 25 lines
        'and the normal width is 80 characters

        Dim strCredits As String = "                        Michael Gedge and James Bensley                        " & vbNewLine & "                         Property of Future Projects                          " & vbNewLine & vbNewLine & "                               Free To Distribute                               " & vbNewLine & vbNewLine & "     Please share this application with all your friends, family and admins    " & vbNewLine & "                    and keep the worlds servers clean!                       " 'A string variable to store the programs credits
        Dim intLineCount As Integer = 0 'An integer variable to store the number of lines on show

        For intLoop = 1 To Len(strCredits) 'Loop round the length of the credits
            Select Case intLoop
                Case Is <= 80 ' 32
                    intLineCount = 0
                    Exit Select
                Case Is <= 161 ' 29
                    intLineCount = 1
                    Exit Select
                Case Is <= 241 ' 20
                    intLineCount = 3
                    Exit Select
                Case Is <= 321 ' 71
                    intLineCount = 6
                    Exit Select
                Case Is <= 400 ' 33
                    intLineCount = 7
                    Exit Select
            End Select
            Console.WriteLine(Left(strCredits, intLoop)) 'Write the credits string upto the point of the loop
            For intLoop2 = 1 To (23 - intLineCount) 'And blank of the rest of the screen
                Console.WriteLine("")
            Next 'Next blank line
            System.Threading.Thread.CurrentThread.Sleep(100) 'Wait between each character printing, Time in milliseconds
        Next 'Next character in the credits string
        Console.WriteLine(strCredits) 'Finish by printing the whole credits string

    End Sub 'End the Credits() Sub

End Module 'End the Module
